using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Infragistics.Win.UltraWinListView;

namespace Infragistics.Win.Samples
{
	#region frmMain class
	/// <summary>
	/// Main dialog for the WinListView DragDrop sample.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		#region Member variables

		private System.Windows.Forms.Panel pnlLeft;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel pnlRight;
		private Infragistics.Win.UltraWinListView.UltraListView lvwDrag;
		private Infragistics.Win.UltraWinListView.UltraListView lvwDrop;
		private System.ComponentModel.Container components = null;

		DragDropManager				dragManager = null;
		DragDropManager				dropManager = null;
		Cursor[]					dragCursors = null;
		Bitmap[]					bitmaps = null;

		#endregion Member variables

		#region Constructor

		/// <summary>
		/// Creates a new instance of the <see cref="frmMain"/> class.
		/// </summary>
		public frmMain()
		{
			this.InitializeComponent();
			this.InitializeUI();
		}

		#endregion Constructor

		#region Windows Form Designer generated code

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if ( disposing )
			{
				if ( this.components != null ) 
				{
					components.Dispose();
				}

				//	Dispose of the drag cursors
				if ( this.dragCursors != null )
				{
					for ( int i = 0; i < this.dragCursors.Length; i ++ )
					{
						if ( this.dragCursors[i] == null )
							continue;

						this.dragCursors[i].Dispose();
						this.dragCursors[i] = null;
					}
				}

				//	Dispose of the bitmaps
				if ( this.bitmaps != null )
				{
					for ( int i = 0; i < this.bitmaps.Length; i ++ )
					{
						if ( this.bitmaps[i] == null )
							continue;

						this.bitmaps[i].Dispose();
						this.bitmaps[i] = null;
					}
				}

				//	Dispose of the DragDropManager instances
				if ( this.dragManager != null )
				{
					this.dragManager.Dispose();
					this.dragManager = null;
				}

				if ( this.dropManager != null )
				{
					this.dropManager.Dispose();
					this.dropManager = null;
				}
			}

			base.Dispose( disposing );
		}

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.pnlLeft = new System.Windows.Forms.Panel();
            this.lvwDrag = new Infragistics.Win.UltraWinListView.UltraListView();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.pnlRight = new System.Windows.Forms.Panel();
            this.lvwDrop = new Infragistics.Win.UltraWinListView.UltraListView();
            
            this.pnlLeft.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.lvwDrag)).BeginInit();
            this.pnlRight.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.lvwDrop)).BeginInit();
            this.SuspendLayout();
            // 
            // pnlLeft
            // 
            this.pnlLeft.Controls.Add(this.lvwDrag);
            this.pnlLeft.Dock = System.Windows.Forms.DockStyle.Left;
            this.pnlLeft.Location = new System.Drawing.Point(0, 0);
            this.pnlLeft.Name = "pnlLeft";
            this.pnlLeft.Size = new System.Drawing.Size(394, 414);
            this.pnlLeft.TabIndex = 0;
            // 
            // lvwDrag
            // 
            this.lvwDrag.Dock = System.Windows.Forms.DockStyle.Fill;
            this.lvwDrag.Location = new System.Drawing.Point(0, 0);
            this.lvwDrag.Name = "lvwDrag";
            this.lvwDrag.Size = new System.Drawing.Size(394, 414);
            this.lvwDrag.TabIndex = 0;
            this.lvwDrag.Text = "ultraListView1";
            // 
            // splitter1
            // 
            this.splitter1.BackColor = System.Drawing.SystemColors.ControlDark;
            this.splitter1.Location = new System.Drawing.Point(394, 0);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(3, 414);
            this.splitter1.TabIndex = 1;
            this.splitter1.TabStop = false;
            // 
            // pnlRight
            // 
            this.pnlRight.Controls.Add(this.lvwDrop);
            this.pnlRight.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlRight.Location = new System.Drawing.Point(397, 0);
            this.pnlRight.Name = "pnlRight";
            this.pnlRight.Size = new System.Drawing.Size(267, 414);
            this.pnlRight.TabIndex = 2;
            // 
            // lvwDrop
            // 
            this.lvwDrop.Dock = System.Windows.Forms.DockStyle.Fill;
            this.lvwDrop.Location = new System.Drawing.Point(0, 0);
            this.lvwDrop.Name = "lvwDrop";
            this.lvwDrop.Size = new System.Drawing.Size(267, 414);
            this.lvwDrop.TabIndex = 1;
            this.lvwDrop.Text = "ultraListView1";
            // 
            // frmMain
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
            this.ClientSize = new System.Drawing.Size(664, 414);
            this.Controls.Add(this.pnlRight);
            this.Controls.Add(this.splitter1);
            this.Controls.Add(this.pnlLeft);
            this.Name = "frmMain";
            this.Text = "WinListView DragDrop Sample";
            this.pnlLeft.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.lvwDrag)).EndInit();
            this.pnlRight.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.lvwDrop)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		#region Main()
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
        { 
			//Load the IG isl File
			Infragistics.StyleLibrary.GetStyleLibrary style = new Infragistics.StyleLibrary.GetStyleLibrary();
			string islFile = style.GetIsl();
			Infragistics.Win.AppStyling.StyleManager.Load(islFile);

			Application.Run(new frmMain());
		}
		#endregion Main()

		#region Methods

			#region InitializeUI
		/// <summary>
		/// Initializes the user interface.
		/// </summary>
		private void InitializeUI()
		{
			//	Add some items to each of the WinListView controls
			Infragistics.Win.Appearance dragAppearance = new Infragistics.Win.Appearance();
			dragAppearance.Image = this.GetIconAsBitmap( "Drag" );

			Infragistics.Win.Appearance dropAppearance = new Infragistics.Win.Appearance();
			dropAppearance.Image = this.GetIconAsBitmap( "Drop" );

			int itemCount = 100;
			for ( int i = 0; i < itemCount; i ++ )
			{
                UltraListViewItem dragItem = this.lvwDrag.Items.Add(null, string.Format("Drag {0}", i));
                dragItem.Appearance = dragAppearance;

                UltraListViewItem dropItem = this.lvwDrop.Items.Add(null, string.Format("Drop {0}", i));
                dropItem.Appearance = dropAppearance;
			}

			//	Create custom cursors for the move and copy operations
			Cursor dragMoveCursor = this.GetCursor( "Move" );
			Cursor dragCopyCursor = this.GetCursor( "Copy" );

			//	Create a DragDropManager instance for each control; note that we are intentionally
			//	only supporting drag for one and drop for the other for demonstrational purposes.
			this.dragManager = new DragDropManager( new WinListViewDragSource(this.lvwDrag, dragMoveCursor, dragCopyCursor) );
            
			this.dropManager = new DragDropManager( new WinListViewDropTarget(this.lvwDrop) );			
		}
			#endregion InitializeUI

			#region GetCursor
		public Cursor GetCursor( string dragOperationType )
		{
			System.IO.Stream stream = null;
			Type type = this.GetType();

			this.dragCursors = new Cursor[2];

			switch ( dragOperationType )
			{
				case "Copy":
				{
					if ( this.dragCursors[0] == null )
					{						
						stream = type.Module.Assembly.GetManifestResourceStream( type, "DragCopy.cur" );
						this.dragCursors[0] = new Cursor( stream );
						stream.Close();
					}

					return this.dragCursors[0];
				}

				case "Move":
				{
					if ( this.dragCursors[1] == null )
					{						
						stream = type.Module.Assembly.GetManifestResourceStream( type, "DragMove.cur" );
						this.dragCursors[1] = new Cursor( stream );
						stream.Close();
					}

					return this.dragCursors[1];
				}
			}

			return null;
		}
			#endregion GetCursor

			#region GetIconAsBitmap
		public Bitmap GetIconAsBitmap( string dragOrDrop )
		{
			System.IO.Stream stream = null;
			Type type = this.GetType();
			Icon icon = null;
			this.bitmaps = new Bitmap[2];

			switch ( dragOrDrop )
			{
				case "Drag":
				{
					if ( this.bitmaps[0] == null )
					{						
						stream = type.Module.Assembly.GetManifestResourceStream( type, "DragSource.ICO" );
						icon = new Icon( stream );
						this.bitmaps[0] = DrawUtility.IconToBitmap( icon );
						stream.Close();
						icon.Dispose();
					}

					return this.bitmaps[0];
				}

				case "Drop":
				{
					if ( this.bitmaps[1] == null )
					{						
						stream = type.Module.Assembly.GetManifestResourceStream( type, "DropTarget.ICO" );
						icon = new Icon( stream );
						this.bitmaps[1] = DrawUtility.IconToBitmap( icon );
						stream.Close();
						icon.Dispose();
					}

					return this.bitmaps[1];
				}
			}

			return null;
		}
			#endregion GetIconAsBitmap

		#endregion Methods

	}
	#endregion frmMain class
}
